#define max_vertices 100000 // Max number of vertices (for each object)
#define max_polygons 100000 // Max number of polygons (for each object)
#define max_textures 100000 // Max number of textures (for each object)
#define max_normals  100000 // Max number of normals  (for each object)
#define max_mtl 200

int test=0,test1=0,size=0,scale=1000;

// Our vertex type
typedef struct{
    float x,y,z;
}vertex_type;

// The polygon (triangle), 3 numbers that aim 3 vertices
typedef struct{
    int a,b,c,d,at,bt,ct,dt,an,bn,cn,dn;
}polygon_type;

// The mapcoord type, 2 texture coordinates for each vertex
typedef struct{
    float u,v;
}mapcoord_type;

// Our normal type
typedef struct{
    float x,y,z;
}normal_type;

// The object type
typedef struct {
    char$ usef$[max_mtl];
    int usef[max_mtl];
    char$ prefix$;

    int vertices_qty;
    int polygons_qty;
    int textures_qty;
    int normals_qty;

    vertex_type vertex[max_vertices];
    polygon_type polygon[max_polygons];
    mapcoord_type mapcoord[max_textures];
    normal_type normal[max_normals];
    //int id_texture;
} obj_type;//, *obj_type_ptr;

/**********************************************************
 *
 * FUNCTION Load3DS (obj_type_ptr, char *)
 *
 * This function loads a mesh from a 3ds file.
 * Please note that we are loading only the vertices, polygons and mapping lists.
 * If you need to load meshes with advanced features as for example:
 * multi objects, materials, lights and so on, you must insert other chunk parsers.
 *
 *********************************************************/

//int Load3DSobj (obj_type_ptr p_object, char *p_filename)
int Loadobj (obj_type *p_object, char *p_filename)
{
	test1=test;char* aux$="                                         ";
    char* ficin$;char$ op$;
    int v=0,vt=0,vn=0,f=0,usemtl=0;
    char$ prefix$;prefix$=instrrev$(p_filename,'\\');prefix$=leftc$(prefix$,len(prefix$)-4);
	p_object->prefix$=wordc$(prefix$,1);if(test==1){notice(strc$("prefix$=",prefix$));}

	file fic; //File pointer
	fic=open(p_filename,"r");

    if (fic == NULL){ return 0; } //Open the file
	int v0=0,p0=0,t0=0,nvertex=0,npoly=0,ntext=0;//offsets

    while (eof(fic)==0 and error(fic)==0) //Loop to scan the whole file
	{
		ficin$=input$(fic);
        op$=lowerc$(firstwordc$(ficin$));
        //v0=v0+1;
		if (op$==char$("v")){
            v=min(max_vertices-1,v+1);
            ficin$=nextwordc$(ficin$);
            p_object->vertex[v].x=fval(firstwordc$(ficin$));
            ficin$=nextwordc$(ficin$);
            p_object->vertex[v].y=fval(firstwordc$(ficin$));
            ficin$=nextwordc$(ficin$);
            p_object->vertex[v].z=fval(firstwordc$(ficin$));
            }

		if (op$==char$("vn")){
            vn=min(max_normals-1,vn+1);
            ficin$=nextwordc$(ficin$);
            p_object->normal[vn].x=fval(firstwordc$(ficin$));
            ficin$=nextwordc$(ficin$);
            p_object->normal[vn].y=fval(firstwordc$(ficin$));
            ficin$=nextwordc$(ficin$);
            p_object->normal[vn].z=fval(firstwordc$(ficin$));
            }

        if (op$==char$("vt")){
            vt=min(max_textures-1,vt+1);
            ficin$=nextwordc$(ficin$);
            p_object->mapcoord[vt].u=fval(firstwordc$(ficin$));
            ficin$=nextwordc$(ficin$);
            p_object->mapcoord[vt].v=fval(firstwordc$(ficin$));
            }

        if (op$==char$("f")){
            f=min(max_polygons-1,f+1);
            ficin$=nextwordc$(ficin$);
            aux$=firstwordc$(ficin$);
            p_object->polygon[f].a=min(max_vertices-1,val(wordc$(aux$,1,"/")));
            p_object->polygon[f].at=min(max_textures-1,val(wordc$(aux$,2,"/")));
            p_object->polygon[f].an=min(max_normals-1,val(wordc$(aux$,3,"/")));
            ficin$=nextwordc$(ficin$);
            aux$=firstwordc$(ficin$);
            p_object->polygon[f].b=min(max_vertices-1,val(wordc$(aux$,1,"/")));
            p_object->polygon[f].bt=min(max_textures-1,val(wordc$(aux$,2,"/")));
            ficin$=nextwordc$(ficin$);
            aux$=firstwordc$(ficin$);
            p_object->polygon[f].c=min(max_vertices-1,val(wordc$(aux$,1,"/")));
            p_object->polygon[f].ct=min(max_textures-1,val(wordc$(aux$,2,"/")));
            ficin$=nextwordc$(ficin$);
            if (strcmp(ficin$,"")==0){
              p_object->polygon[f].d=0;}
            else {
              aux$=firstwordc$(ficin$);
              p_object->polygon[f].d=min(max_vertices-1,val(wordc$(aux$,1,"/")));
              p_object->polygon[f].dt=min(max_textures-1,val(wordc$(aux$,2,"/")));
              //if(test==1){test=0;notice(strc$("d_ficin=",ficin$));};
              }
            }

       if (op$==char$("usemtl")){
            usemtl=min(max_mtl-1,usemtl+1);
            p_object->usef[usemtl]=f;
            ficin$=nextwordc$(ficin$);
            p_object->usef$[usemtl]=wordc$(wordc$(firstwordc$(ficin$),1,chr$(10)),1,chr$(13));
            //if(test==1){test=0;notice(strc$("usef$=",p_object->usef$[usemtl]));};
            }
	}
	close(fic);
    usemtl=min(max_mtl-1,usemtl+1);
    p_object->usef[usemtl]=f+999;
    p_object->usef[0]=0;
    p_object->vertices_qty =v;
    p_object->polygons_qty =f;
    p_object->textures_qty =vt;
    p_object->normals_qty =vn;
    //notice(strc$("usemtl=",str$(usemtl)));
    //notice(strc$("v0=",str$(v0)));
    //notice(strc$("v=",str$(v)));
    return (1); // Returns ok
}

void drawobj(obj_type * object,char* textlist$,char* defauttex$)
{
    int f,v,vt,vn,gltri=0;float vmax=0.001,k,kk;
    float x1,y1,z1,x2,y2,z2,x3,y3,z3,vx1,vy1,vz1,vx2,vy2,vz2,vx3,vy3,vz3;
    if (size>0){
    for (v=1;v<=object->vertices_qty;v++)
    {
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].x));
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].y));
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].z));
    };
    kk=size/vmax;}else{kk=1;};scale=int(kk*1000);

    int usemtl=0,usef=object->usef[usemtl],itext=0;usef=0;
    char$ usef$,text0$,prefix$,defautext$;usef$=object->usef$[usemtl];prefix$=object->prefix$;
    defautext$=defauttex$;if (defautext$[0]==0){defautext$=strc$(prefix$,prefix$);};
    char* text$;text$=textlist$;char* aux$="               ";int test1=test;
    if(test1==1){notice(strc$("usef$=",usef$," textlist$=",text$));}

    for (f=1;f<=object->polygons_qty;f++)
    {
        if(f>usef){ while(f>usef and usemtl<(max_mtl-1)){++usemtl;usef=object->usef[usemtl];};
                              usef$=lowerc$(strc$(prefix$,object->usef$[usemtl-1]));
                              text$=textlist$;text0$=firstwordc$(text$);
                              if(test1==1){confirm(strc$("usef$=",usef$,"/textlist$=",text$),aux$);
                                          if(!strcmp(aux$,"no")){test1=0;} }
                              while(text0$[0]!=0 and usef$!=text0$){text$=nextwordc$(text$);
                                                                   text$=nextwordc$(text$);
                                                                   text0$=firstwordc$(text$);}
                              if(usef$==text0$){text$=nextwordc$(text$);
                                               text0$=firstwordc$(text$);itext=val(text0$);
                                               if(test1==1){
                                               notice(strc$("bindtext=",usef$," itext=",str$(itext)));
                                                }
                                               glBindTexture(GL_TEXTURE_2D,itext);
                                               }
                              else{
                              text$=textlist$;text0$=firstwordc$(text$);usef$=defautext$;
                              if(test1==1){confirm(strc$("usef$=",usef$,"/textlist$=",text$),aux$);
                                          if(!strcmp(aux$,"no")){test1=0;} }
                              while(text0$[0]!=0 and usef$!=text0$){text$=nextwordc$(text$);
                                                                   text$=nextwordc$(text$);
                                                                   text0$=firstwordc$(text$);}
                              if(usef$==text0$ and text0$[0]!=0){text$=nextwordc$(text$);
                                               text0$=firstwordc$(text$);itext=val(text0$);
                                               if(test1==1){
                                               notice(strc$("bindtext=",usef$," itext=",str$(itext)));
                                                }
                                               glBindTexture(GL_TEXTURE_2D,itext);
                                               }

                                   }
                              }
        if (object->polygon[f].d==0){
            if (gltri!=1){
                if (gltri!=0){glEnd();};gltri=1;glBegin(GL_TRIANGLES);}
            }
            else
            {
            if (gltri!=2){
                if (gltri!=0){glEnd();};gltri=2;glBegin(GL_QUADS);}
            };
        //-----------------  VERTEX 1-----------------
        vt=object->polygon[f].at;
        v=object->polygon[f].a;
        vn=object->polygon[f].an;
        if (vn>0){ glNormal3f( object->normal[vn].x, object->normal[vn].y, object->normal[vn].z); };
        if (vn==0){vn=object->polygon[f].a; x1=object->vertex[vn].x; y1=object->vertex[vn].y; z1=object->vertex[vn].z;
                   vn=object->polygon[f].b; x2=object->vertex[vn].x; y2=object->vertex[vn].y; z2=object->vertex[vn].z;
                   vn=object->polygon[f].c; x3=object->vertex[vn].x; y3=object->vertex[vn].y; z3=object->vertex[vn].z;
                   vx1=x2-x1; vy1=y2-y1; vz1=z2-z1;
                   vx2=x3-x1; vy2=y3-y1; vz2=z3-z1;
                   vx3=(vz2*vy1)-(vy2*vz1);
                   vy3=(vx2*vz1)-(vz2*vx1);
                   vz3=(vy2*vx1)-(vx2*vy1);
                   glNormal3f(vx3,vy3,vz3); };
        if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
        else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
             };
        glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);

        //----------------- VERTEX 2-----------------
        vt=object->polygon[f].bt;
        v=object->polygon[f].b;
        if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
        else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
             };
        glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);

        //----------------- VERTEX 3-----------------
        vt=object->polygon[f].ct;
        v=object->polygon[f].c;
        if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
        else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
             };
        glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);

        if (object->polygon[f].d!=0){
        //----------------- VERTEX 4-----------------
         vt=object->polygon[f].dt;
         v=object->polygon[f].d;
         if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
         else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
              };
         glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);
         }

    }
    glEnd();
}

void drawobj2(obj_type * object) // default texture only
{
    int f,v,vt,vn;float vmax=0.001,k,kk;
    float x1,y1,z1,x2,y2,z2,x3,y3,z3,vx1,vy1,vz1,vx2,vy2,vz2,vx3,vy3,vz3;
    for (v=1;v<=object->vertices_qty;v++)
    {
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].x));
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].y));
        vmax=max(vmax,0.5*vmax+0.5*fabs(object->vertex[v].z));
    };
    k=1/vmax;
    if (size>0){kk=size/vmax;}else{kk=1;};

    for (f=1;f<=object->polygons_qty;f++)
    {
        if (object->polygon[f].d==0){glBegin(GL_TRIANGLES);}else{glBegin(GL_QUADS);};
        //-----------------  VERTEX 1-----------------
        vt=0;//object->polygon[f].at;
        v=object->polygon[f].a;
        vn=object->polygon[f].an;
        if (vn>0){ glNormal3f( object->normal[vn].x, object->normal[vn].y, object->normal[vn].z); };
        if (vn==0){vn=object->polygon[f].a; x1=object->vertex[vn].x; y1=object->vertex[vn].y; z1=object->vertex[vn].z;
                   vn=object->polygon[f].b; x2=object->vertex[vn].x; y2=object->vertex[vn].y; z2=object->vertex[vn].z;
                   vn=object->polygon[f].c; x3=object->vertex[vn].x; y3=object->vertex[vn].y; z3=object->vertex[vn].z;
                   vx1=x2-x1; vy1=y2-y1; vz1=z2-z1;
                   vx2=x3-x1; vy2=y3-y1; vz2=z3-z1;
                   vx3=(vz2*vy1)-(vy2*vz1);
                   vy3=(vx2*vz1)-(vz2*vx1);
                   vz3=(vy2*vx1)-(vx2*vy1);
                   glNormal3f(vx3,vy3,vz3); };
        if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
        else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
             };
        glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);

        //----------------- VERTEX 2-----------------
        vt=0;//object->polygon[f].bt;
        v=object->polygon[f].b;
        if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
        else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
             };
        glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);

        //----------------- VERTEX 3-----------------
        vt=0;//object->polygon[f].ct;
        v=object->polygon[f].c;
        if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
        else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
             };
        glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);

        if (object->polygon[f].d!=0){
        //----------------- VERTEX 4-----------------
         vt=0;//object->polygon[f].dt;
         v=object->polygon[f].d;
         if (vt==0){ glTexCoord2f( object->vertex[v].x*k, object->vertex[v].y*k); }
         else { glTexCoord2f( object->mapcoord[vt].u, object->mapcoord[vt].v);
              };
         glVertex3f( object->vertex[v].x*kk,
                    object->vertex[v].y*kk,
                    object->vertex[v].z*kk);
         }

       glEnd();

    }
}
